Package org.jcsp.awt

# Class ActiveButton

java.lang.Object
java.awt.Component
java.awt.Button
org.jcsp.awt.ActiveButton

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `Accessible`, `CSProcess`

public class ActiveButton extends Button implements CSProcess
``java.awt.Button`` with a channel interface.

## Process Diagram

## Description

`ActiveButton` is a process extension of `java.awt.Button` with channels for run-time configuration and event notification. The event channels should be connected to one or more application-specific server processes (instead of registering a passive object as a Listener to this component).

All channels are optional. The `configure` and `event` channels are settable from a constructor. The `event` channel delivers the current button label whenever the `ActiveButton` is pressed. Other event channels can be added to notify the occurrence of any other events the component generates (by calling the appropriate `add` XXX `EventChannel` method before the process is run). Messages can be sent down the `configure` channel at any time to configure the component. See the table below for details.

All channels are managed by independent internal handler processes. It is, therefore, safe for a serial application process both to service an event channel and configure the component -- no deadlock can occur.

IMPORTANT: it is essential that event channels from this process are always serviced -- otherwise the Java Event Thread will be blocked and the GUI will stop responding. A simple way to guarantee this is to use channels configured with overwriting buffers. For example:

       final One2OneChannel myButtonEvent = Channel.one2one (new OverWriteOldestBuffer (n));

       final ActiveButton myButton =
         new ActiveButton (null, myButtonEvent.out (), "Press Me");

This will ensure that the Java Event Thread will never be blocked. Slow or inattentive readers may miss rapidly generated events, but the `n` most recent events will always be available.

## Channel Protocols

Input Channels
configure | String | Change the label on the `ActiveButton` to the value of the `String`.

Boolean

1. If this is the `Boolean.TRUE` object, the button is made active.
2. If this is the `Boolean.FALSE` object, the button is made inactive.
3. Other `Boolean` objects are ignored.

ActiveButton.Configure | Invoke the user-defined `Configure.configure` method on the button.
Output Channels
event | String | The label on the `ActiveButton` (when the button is pressed and released).
componentEvent | ComponentEvent | See the ``addComponentEventChannel`` method.
focusEvent | FocusEvent | See the ``addFocusEventChannel`` method.
keyEvent | KeyEvent | See the ``addKeyEventChannel`` method.
mouseEvent | MouseEvent | See the ``addMouseEventChannel`` method.
mouseMotionEvent | MouseEvent | See the ``addMouseMotionEventChannel`` method.

## Example

     import java.awt.*;
     import org.jcsp.lang.*;
     import org.jcsp.util.*;
     import org.jcsp.awt.*;

     public class ActiveButtonExample {

       public static void main (String argv[]) {

         final Frame root = new Frame ("ActiveButton Example");

         final String[] label = {"Hello World", "Rocket Science", "CSP",
                                 "Monitors", "Ignore Me", "Goodbye World"};

         final Any2OneChannel event = Channel.any2one (new OverWriteOldestBuffer (10));

         final ActiveButton[] button = new ActiveButton[label.length];
         for (int i = 0; i invalid input: '<' label.length; i++) {
           button[i] = new ActiveButton (null, event.out (), label[i]);
           button[i].setBackground (Color.green);
         }

         root.setSize (300, 200);
         root.setLayout (new GridLayout (label.length/2, 2));
         for (int i = 0; i invalid input: '<' label.length; i++) {
           root.add (button[i]);
         }
         root.setVisible (true);

         new Parallel (
           new CSProcess[] {
             new Parallel (button),
             new CSProcess () {
               public void run () {
                 boolean running = true;
                 while (running) {
                   final String s = (String) event.in ().read ();
                   System.out.println ("Button `" + s + "' pressed ...");
                   running = (s != label[label.length - 1]);
                 }
                 root.setVisible (false);
                 System.exit (0);
               }
             }
           }
         ).run ();
       }

     }

Author:
  P.D. Austin and P.H. Welch
See Also:
  - `Button`
  - `ComponentEvent`
  - `FocusEvent`
  - `KeyEvent`
  - `MouseEvent`
  - `OverWriteOldestBuffer`
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static interface`
`ActiveButton.Configure`
This enables general configuration of this component.

## Nested classes/interfaces inherited from class java.awt.Button

`Button.AccessibleAWTButton`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`ActiveButton()`
Constructs a new `ActiveButton` with no label, configuration or event channels.
`ActiveButton(String s)`
Constructs a new `ActiveButton` with no configuration or event channels.
`ActiveButton(ChannelInput configure, ChannelOutput event)`
Constructs a new `ActiveButton` with no initial label.
`ActiveButton(ChannelInput configure, ChannelOutput event, String s)`
Constructs a new `ActiveButton`.

## Method Summary

Modifier and Type
Method
Description
`void`
`addComponentEventChannel(ChannelOutput componentEvent)`
Add a new channel to this component that will be used to notify that a `ComponentEvent` has occurred.
`void`
`addEventChannel(ChannelOutput event)`
Add a new channel to this component that will be used to notify that the button has been pressed.
`void`
`addFocusEventChannel(ChannelOutput focusEvent)`
Add a new channel to this component that will be used to notify that a `FocusEvent` has occurred.
`void`
`addKeyEventChannel(ChannelOutput keyEvent)`
Add a new channel to this component that will be used to notify that a `KeyEvent` has occurred.
`void`
`addMouseEventChannel(ChannelOutput mouseEvent)`
Add a new channel to this component that will be used to notify that a `MouseEvent` has occurred.
`void`
`addMouseMotionEventChannel(ChannelOutput mouseMotionEvent)`
Add a new channel to this component that will be used to notify that a `MouseMotionEvent` has occurred.
`void`
`run()`
The main body of this process.
`void`
`setConfigureChannel(ChannelInput configure)`
Sets the configuration channel for this `ActiveButton`.

### Methods inherited from class java.awt.Button

`addActionListener, addNotify, getAccessibleContext, getActionCommand, getActionListeners, getLabel, getListeners, paramString, processActionEvent, processEvent, removeActionListener, setActionCommand, setLabel`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMinimumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, minimumSize, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, preferredSize, prepareImage, prepareImage, print, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setMixingCutoutShape, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle, update, validate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ActiveButton

public ActiveButton()
Constructs a new `ActiveButton` with no label, configuration or event channels.

### ActiveButton

public ActiveButton(String s)
Constructs a new `ActiveButton` with no configuration or event channels.

Parameters:
  `s` - the initial label displayed on the button.

### ActiveButton

public ActiveButton(ChannelInput configure, ChannelOutput event)
Constructs a new `ActiveButton` with no initial label.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.
  `event` - the current label will be output when the button is pressed -- can be null if no notification is required.

### ActiveButton

public ActiveButton(ChannelInput configure, ChannelOutput event, String s)
Constructs a new `ActiveButton`.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.
  `event` - the current label will be output when the button is pressed -- can be null if no notification is required.
  `s` - the initial label displayed on the button.

## Method Details

### setConfigureChannel

public void setConfigureChannel(ChannelInput configure)
Sets the configuration channel for this `ActiveButton`. This method overwrites any configuration channel set in the constructor.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.

### addEventChannel

public void addEventChannel(ChannelOutput event)
Add a new channel to this component that will be used to notify that the button has been pressed. This should be used instead of registering an ActionListener with the component. It is possible to add more than one channel by calling this method multiple times. If the channel passed is `null`, no action will be taken. This method is an alternative to setting such a channel in the constructor.

NOTE: This method must be called before this process is run.

Parameters:
  `event` - the channel down which to send the current label when the button is pressed.

### addComponentEventChannel

public void addComponentEventChannel(ChannelOutput componentEvent)
Add a new channel to this component that will be used to notify that a `ComponentEvent` has occurred. This should be used instead of registering a ComponentListener with the component. It is possible to add more than one channel by calling this method multiple times. If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `componentEvent` - the channel down which to send ComponentEvents.

### addFocusEventChannel

public void addFocusEventChannel(ChannelOutput focusEvent)
Add a new channel to this component that will be used to notify that a `FocusEvent` has occurred. This should be used instead of registering a FocusListener with the component. It is possible to add more than one channel by calling this method multiple times. If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `focusEvent` - the channel down which to send FocusEvents.

### addKeyEventChannel

public void addKeyEventChannel(ChannelOutput keyEvent)
Add a new channel to this component that will be used to notify that a `KeyEvent` has occurred. This should be used instead of registering a KeyListener with the component. It is possible to add more than one channel by calling this method multiple times. If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `keyEvent` - the channel down which to send KeyEvents.

### addMouseEventChannel

public void addMouseEventChannel(ChannelOutput mouseEvent)
Add a new channel to this component that will be used to notify that a `MouseEvent` has occurred. This should be used instead of registering a MouseListener with the component. It is possible to add more than one channel by calling this method multiple times. If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `mouseEvent` - the channel down which to send MouseEvents.

### addMouseMotionEventChannel

public void addMouseMotionEventChannel(ChannelOutput mouseMotionEvent)
Add a new channel to this component that will be used to notify that a `MouseMotionEvent` has occurred. This should be used instead of registering a MouseMotionListener with the component. It is possible to add more than one channel by calling this method multiple times. If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `mouseMotionEvent` - the channel down which to send MouseMotionEvents.

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`